GNU Radio 2.x: gr_sync_interpolator Class Reference

Main Page | Modules | Namespace List | Class Hierarchy | Class List | File List | Class Members | File Members

# gr_sync_interpolator Class Reference
[Signal Processing Blocks]

`#include <gr_sync_interpolator.h>`

Inheritance diagram for gr_sync_interpolator:

[legend]
Collaboration diagram for gr_sync_interpolator:

[legend]
List of all members.

## Detailed Description

synchronous 1:N input to output with history

Override work to provide the signal processing implementation.

## Public Member Functions
unsigned | interpolation () const
void | set_interpolation (unsigned interpolation)
void | forecast (int noutput_items, gr_vector_int &ninput_items_required)
| Estimate input requirements given output request.
int | general_work (int noutput_items, gr_vector_int &ninput_items, gr_vector_const_void_star &input_items, gr_vector_void_star &output_items)
| compute output items from input items
int | fixed_rate_ninput_to_noutout (int ninput)
int | fixed_rate_noutput_to_ninput (int noutput)
| Given noutput samples, return number of input samples required to produce noutput. N.B. this is only defined if fixed_rate returns true. Generally speaking, you don't need to override this.
## Protected Member Functions
| gr_sync_interpolator (const std::string &name, gr_io_signature_sptr input_signature, gr_io_signature_sptr output_signature, unsigned interpolation)

## Constructor & Destructor Documentation

gr_sync_interpolator::gr_sync_interpolator | ( | const std::string & | name,
|  | gr_io_signature_sptr | input_signature,
|  | gr_io_signature_sptr | output_signature,
|  | unsigned | interpolation
| ) | `[protected]`

## Member Function Documentation

int gr_sync_interpolator::fixed_rate_ninput_to_noutout | ( | int | ninput | ) |

int gr_sync_interpolator::fixed_rate_noutput_to_ninput | ( | int | noutput | ) | `[virtual]`

| Given noutput samples, return number of input samples required to produce noutput. N.B. this is only defined if fixed_rate returns true. Generally speaking, you don't need to override this. Reimplemented from gr_sync_block.

void gr_sync_interpolator::forecast | ( | int | noutput_items,
|  | gr_vector_int & | ninput_items_required
| ) | `[virtual]`

  | Estimate input requirements given output request. Parameters:
  | noutput_items | number of output items to produce
  | ninput_items_required | number of input items required on each input stream
Given a request to product `noutput_items`, estimate the number of data items required on each input stream. The estimate doesn't have to be exact, but should be close. Reimplemented from gr_sync_block.

int gr_sync_interpolator::general_work | ( | int | noutput_items,
|  | gr_vector_int & | ninput_items,
|  | gr_vector_const_void_star & | input_items,
|  | gr_vector_void_star & | output_items
| ) | `[virtual]`

  | compute output items from input items Parameters:
  | noutput_items | number of output items to write on each output stream
  | ninput_items | number of input items available on each input stream
  | input_items | vector of pointers to the input items, one entry per input stream
  | output_items | vector of pointers to the output items, one entry per output stream
Returns: number of items actually written to each output stream, or -1 on EOF. It is OK to return a value less than noutput_items. -1 <= return value <= noutput_items general_work must call consume or consume_each to indicate how many items were consumed on each input stream. Reimplemented from gr_sync_block.

unsigned gr_sync_interpolator::interpolation | ( |  | ) | const`[inline]`

void gr_sync_interpolator::set_interpolation | ( | unsigned | interpolation | ) | `[inline]`

The documentation for this class was generated from the following files:

- gr_sync_interpolator.h
- gr_sync_interpolator.cc